#!/usr/bin/perl

#    This script is part of synaptics RPM for Aurox and tries to add
#    synaptics driver entries to existing XF86Config file
#    It's not the pretty one, but it works...
#
#    Copyright (C) 2004 Jaroslaw Gorny
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#


open (INFILE,"/etc/X11/XF86Config");
open (OUTFILE,">/etc/X11/XF86Config.new");

# check if flags section is present
$flags=system("cat /etc/X11/XF86Config|grep ServerFlags");

#check if synaptics section is present
$syn=system("cat /etc/X11/XF86Config|grep -e 'Driver.*synaptics'");

#check if synaptics is loaded
$loaded=system("cat /etc/X11/XF86Config|grep -e 'Load.*synaptics'");

while (<INFILE>){
# add section ServerFlags if it doesn't exist
    if ($flags) {
	$_ =~ s/(^Section\s+\"ServerLayout\".*)/Section\t\"ServerFlags\"\n\tOption\ \"AllowMouseOpenFail\"\nEndSection\n\n$1/;
    }
# add synaptics section if it doesn't exist
    if ($syn) {
	$_ =~ s/(^Section\s+\"Monitor\".*)/Section\t\"InputDevice\"\n\tIdentifier\ \"SynapticsMouse\"\n\tDriver\ \"synaptics\"\n\tOption\ \"Device\"\ \"\/dev\/input\/mouse0\"\n\tOption\ \"Protocol\"\ \"auto\"\n\tOption\ \"SHMConfig\"\ \"on\"\n\tOption\ \"ZAxisMapping\"\ \"4\ 5\"\nEndSection\n\n$1/;
    }
# change Mouse0 to SynapticsMouse
    $_ =~ s/(.*InputDevice.*)(Mouse\d)(.*[^\"].*$)/$1SynapticsMouse$3/;
# remove dri
    $_ =~ s/(^[^\#].*\"dri\".*)/\#$1/;
# load synaptics
    if ($loaded) {
	$_ =~ s/(^Section\s+\"Module\".*)/$1\n\tLoad\ \ \"synaptics\"/;
    }
# change /dev/input/mice to /dev/input/mouse1
# and add SendCoreEvents to this section
    $_ =~ s/(.*\"\/dev\/input\/)(mice)(\".*)/$1mouse1$3\n\tOption\t\ \ \ \ \"SendCoreEvents\"\ \"true\"/;
    
print OUTFILE;
}
